src/Entity/Product.php
<?php

namespace App\Entity;

use App\Repository\ProductRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ProductRepository::class)
 */
class Product
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $name;

    /**
     * @ORM\Column(type="integer")
     */
    private $base_price;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    private $final_price_sum;

    /**
     * @ORM\OneToMany(targetEntity=Reservation::class, mappedBy="product")
     */
    private $reservations;

    public function __construct()
    {
        return $this->getName();
        $this->reservations = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getBasePrice(): ?int
    {
        return $this->base_price;
    }

    public function setBasePrice(int $base_price): self
    {
        $this->base_price = $base_price;

        return $this;
    }

    public function getFinalPricesSum(): ?int
    {
        return $this->final_price_sum;
    }

    public function setFinalPricesSum(int $final_price_sum): self
    {
        $this->final_price_sum = $final_price_sum;

        return $this;
    }

    /**
     * @return Collection|Reservation[]
     */
    public function getReservations(): Collection
    {
        return $this->reservations;
    }

    public function addReservation(Reservation $reservation): self
    {
        if (!$this->reservations->contains($reservation)) {
            $this->reservations[] = $reservation;
            $reservation->setProduct($this);
        }

        return $this;
    }

    public function removeReservation(Reservation $reservation): self
    {
        if ($this->reservations->removeElement($reservation)) {
            // set the owning side to null (unless already changed)
            if ($reservation->getProduct() === $this) {
                $reservation->setProduct(null);
            }
        }

        return $this;
    }

    public function calculateFinalPricesSum()
    {
        return $this->getFinalPricesSum() + $this->getBasePrice();
    }

    public function getUpdatedFinalPricesSum($entityManager, $productBasePrice)
    {
        $reservations = $this->getReservations();
        $newPrice = 0;

        if (!empty($reservations)) {
            foreach($reservations as $reservation) {
                $newPrice += $productBasePrice;
                $reservation->setBasePrice($productBasePrice);
                $reservation->setFinalPrice($productBasePrice);

                $entityManager->persist($reservation);
            }
        }

        return $newPrice;
    }
}

src/Entity/Reservation.php
<?php

namespace App\Entity;

use App\Repository\ReservationRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ReservationRepository::class)
 */
class Reservation
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity=Product::class, inversedBy="reservations")
     */
    private $product;

    /**
     * @ORM\Column(type="integer")
     */
    private $base_price;

    /**
     * @ORM\Column(type="integer")
     */
    private $final_price;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getProduct(): ?Product
    {
        return $this->product;
    }

    public function setProduct(?Product $product): self
    {
        $this->product = $product;

        return $this;
    }

    public function getBasePrice(): ?int
    {
        return $this->base_price;
    }

    public function setBasePrice(int $base_price): self
    {
        $this->base_price = $base_price;

        return $this;
    }

    public function getFinalPrice(): ?int
    {
        return $this->final_price;
    }

    public function setFinalPrice(int $final_price): self
    {
        $this->final_price = $final_price;

        return $this;
    }

    public function getUpdatedFinalPricesSum($entityManager, $reservationNewFinalPrice)
    {
        $product = $this->getProduct();
        $productReservationsCount = count($product->getReservations());
        $reservationFinalPrice = $this->getFinalPrice();
        $actualProductFinalPriceSum = $product->getFinalPricesSum();
        $actualReservationFinalPrice = $actualProductFinalPriceSum / $productReservationsCount;

        return ($productReservationsCount * $actualReservationFinalPrice) - ($reservationFinalPrice - (int)$reservationNewFinalPrice);
    }
}

templates/index/editProduct.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit product{% endblock %}

{% block body %}


<div class="container mt-5">
    <div class="row">
        <div class="col-12">
            <h1 class="text-center mb-5">TagThing Test</h1>
            <div class="card">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Edit product: #{{ product.id }}
                    <a href="{{ path('index') }}" type="button" class="btn btn-sm btn-primary">Back to products</a>
                </h5>
                <div class="card-body">
                    <form method="post" action="{{ path('update_product', {'id' : product.id}) }}">
                        <div class="form-group">
                            <label for="name">Name</label>
                            <input type="text" class="form-control" id="name" name="name" value="{{ product.name }}">
                        </div>
                        <div class="form-group">
                            <label for="base_price">Base price</label>
                            <input type="number" class="form-control" id="base_price" name="base_price" value="{{ product.basePrice }}">
                        </div>
                        <div class="form-group text-center">
                            <button type="submit" class="btn btn-primary">Update</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

templates/index/editReservation.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit reservation{% endblock %}

{% block body %}


<div class="container mt-5">
    <div class="row">
        <div class="col-12">
            <h1 class="text-center mb-5">TagThing Test</h1>
            <div class="card">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Edit reservation: #{{ reservation.id }}
                    <a href="{{ path('index') }}" type="button" class="btn btn-sm btn-primary">Back to reservations</a>
                </h5>
                <div class="card-body">
                    <form method="post" action="{{ path('update_reservation', {'id' : reservation.id}) }}">
                        <div class="form-group">
                            <label for="product">Products</label>
                            <select class="form-control" id="product" name="product">
                                {% for product in products %}
                                    <option value="{{ product.id }}" {{ product.id == reservation.product.id ? 'selected' : ''}}>{{ product.name }}</option>
                                {% endfor %}
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="final_price">Final price</label>
                            <input type="number" class="form-control" id="final_price" name="final_price" value="{{ reservation.finalPrice }}">
                        </div>
                        <div class="form-group text-center">
                            <button type="submit" class="btn btn-primary">Update</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

templates/index/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}TagThing Test{% endblock %}

{% block body %}


<div class="container mt-5">
    <div class="row">
        <div class="col-12">
            <h1 class="text-center mb-5">TagThing Test</h1>
            <div class="card">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Products
                    <a href="{{ path('new_product') }}" type="button" class="btn btn-sm btn-primary">Add new product</a>
                </h5>
                <div class="card-body">
                    <table class="table">
                    <thead class="thead-dark">
                        <tr>
                        <th scope="col">#</th>
                        <th scope="col">Name</th>
                        <th scope="col">Base Price</th>
                        <th scope="col">Final Price Sum</th>
                        <th scope="col">Edit</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% if products is not empty %}
                            {% for product in products %}
                                <tr>
                                    <th scope="row">{{ product.id }}</th>
                                    <td>{{ product.name }}</td>
                                    <td>{{ product.basePrice | number_format }} HUF</td>
                                    <td>{{ product.finalPricesSum | number_format }} HUF</td>
                                    <td>
                                        <a role="button" title="Edit" data-toggle="tooltip" href="{{ path('edit_product', {'id' : product.id}) }}">
                                            <i class="material-icons text-warning mr-3">&#xE254;</i>
                                        </a>
                                    </td>
                                </tr>
                            {% endfor %}
                        {% else %}
                            <tr>
                                <th colspan="5">No products</th>
                            </tr>
                        {% endif %}
                    </tbody>
                </table>
                </div>
            </div>

            <div class="card mt-5">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Reservations 
                    <a href="{{ path('new_reservation') }}" type="button" class="btn btn-sm btn-primary">Add new reservation</a>
                </h5>
                <div class="card-body">
                    <table class="table">
                    <thead class="thead-dark">
                        <tr>
                        <th scope="col">#</th>
                        <th scope="col">Product</th>
                        <th scope="col">Base Price</th>
                        <th scope="col">Final Price</th>
                        <th scope="col">Actions</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% if reservations is not empty %}
                            {% for reservation in reservations %}
                                <tr>
                                    <th scope="row">{{ reservation.id }}</th>
                                    <td>{{ reservation.product.name }}</td>
                                    <td>{{ reservation.basePrice | number_format }} HUF</td>
                                    <td>{{ reservation.finalPrice | number_format }} HUF</td>
                                    <td>
                                        <a role="button" title="Edit" data-toggle="tooltip" href="{{ path('edit_reservation', {'id' : reservation.id}) }}">
                                            <i class="material-icons text-warning mr-3">&#xE254;</i>
                                        </a>
                                        <a role="button" title="Delete" data-toggle="tooltip" href="{{ path('delete_reservation', {'id' : reservation.id}) }}">
                                            <i class="material-icons text-danger">&#xE872;</i>
                                        </a>
                                    </td>
                                </tr>
                            {% endfor %}
                        {% else %}
                            <tr>
                                <th colspan="5">No reservations</th>
                            </tr>
                        {% endif %}
                    </tbody>
                </table>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

templates/index/newProduct.html.twig
{% extends 'base.html.twig' %}

{% block title %}Add new product{% endblock %}

{% block body %}


<div class="container mt-5">
    <div class="row">
        <div class="col-12">
            <h1 class="text-center mb-5">TagThing Test</h1>
            <div class="card">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Add new product
                    <a href="{{ path('index') }}" type="button" class="btn btn-sm btn-primary">Back to products</a>
                </h5>
                <div class="card-body">
                    <form method="post" action="{{ path('save_product') }}">
                        <div class="form-group">
                            <label for="name">Name</label>
                            <input type="text" class="form-control" id="name" name="name" placeholder="Name" required>
                        </div>
                        <div class="form-group">
                            <label for="base_price">Base price</label>
                            <input type="number" class="form-control" id="base_price" name="base_price" placeholder="Base price" required>
                        </div>
                        <div class="form-group text-center">
                            <button type="submit" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

templates/index/newReservation.html.twig
{% extends 'base.html.twig' %}

{% block title %}Add new reservation{% endblock %}

{% block body %}


<div class="container mt-5">
    <div class="row">
        <div class="col-12">
            <h1 class="text-center mb-5">TagThing Test</h1>
            <div class="card">
                <h5 class="card-header d-flex justify-content-between align-items-center">
                    Add new reservation
                    <a href="{{ path('index') }}" type="button" class="btn btn-sm btn-primary">Back to reservations</a>
                </h5>
                <div class="card-body">
                    <form method="post" action="{{ path('save_reservation') }}">
                        <div class="form-group">
                            <label for="product">Products</label>
                            <select class="form-control" id="product" name="product">
                                {% for product in products %}
                                    <option value="{{ product.id }}">{{ product.name }}</option>
                                {% endfor %}
                            </select>
                        </div>
                        <div class="form-group text-center">
                            <button type="submit" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}